;/***********************************************************************************************************************
;* DISCLAIMER
;* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
;* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
;* applicable laws, including copyright laws. 
;* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
;* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
;* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
;* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
;* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
;* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
;* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
;* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
;* following link:
;* http://www.renesas.com/disclaimer
;*
;* Copyright (C) 2012, 2015 Renesas Electronics Corporation. All rights reserved.
;***********************************************************************************************************************/

;/***********************************************************************************************************************
;* File Name    : r_cg_cstart.asm
;* Version      : Code Generator for RL78/G10 V1.04.02.01 [15 May 2015]
;* Device(s)    : R5F10Y47
;* Tool-Chain   : CCRL
;* Description  : This is start up file for CC-RL.
;* Creation Date: 2015/11/20
;***********************************************************************************************************************/
	.public	_start
	.public _exit

;-----------------------------------------------------------------------------
;	RAM section
;-----------------------------------------------------------------------------
.SECTION .dataR, DATA
.SECTION .sdataR, DATA

; !!! [CAUTION] !!!
; The start address of RAM depend on the device in use.
; See the user's manual of the device for the values to be specified.
;   ex. R5F10Y14ASP -> 0x0FFE60
RAM_ADDR_START	.EQU	0x0FFCE0	; Start address of RAM (SAMPLE)
RAM_ADDR_END	.EQU	0x0FFEE0	; End address of RAM +1
;-----------------------------------------------------------------------------
;	stack area
;-----------------------------------------------------------------------------
.SECTION .stack_bss, BSS
_stackend:
	.DS     0x40
_stacktop:

;-----------------------------------------------------------------------------
;	RESET vector
;-----------------------------------------------------------------------------
_start	.VECTOR	0

;-----------------------------------------------------------------------------
;	startup
;-----------------------------------------------------------------------------
.SECTION .text, TEXT
_start:
	;--------------------------------------------------
	; setting the stack pointer
	;--------------------------------------------------
	MOVW	SP,#LOWW(_stacktop)

	;--------------------------------------------------
	; hardware initialization
	;--------------------------------------------------
	CALL	!!_hdwinit

	;--------------------------------------------------
	; initializing RAM
	;--------------------------------------------------
	MOVW	HL,#LOWW(RAM_ADDR_START)
	MOVW	AX,#LOWW(RAM_ADDR_END)
	BR	$L2_RAM
L1_RAM:
	MOV	[HL+0],#0
	INCW	HL
L2_RAM:
	CMPW	AX,HL
	BNZ	$L1_RAM

	;--------------------------------------------------
	; ROM data copy
	;--------------------------------------------------
	; copy external variables having initial value (near)
	MOV	ES,#HIGHW(STARTOF(.data))
	MOVW	BC,#LOWW(SIZEOF(.data))
	BR	$L2_DATA
L1_DATA:
	DECW	BC
	MOV	A,ES:LOWW(STARTOF(.data))[BC]
	MOV	LOWW(STARTOF(.dataR))[BC],A
L2_DATA:
	CLRW	AX
	CMPW	AX,BC
	BNZ	$L1_DATA

	; copy saddr variables having initial value
	MOV	ES,#HIGHW(STARTOF(.sdata))
	MOVW	BC,#LOWW(SIZEOF(.sdata))
	BR	$L2_SDATA
L1_SDATA:
	DECW	BC
	MOV	A,ES:LOWW(STARTOF(.sdata))[BC]
	MOV	LOWW(STARTOF(.sdataR))[BC],A
L2_SDATA:
	CLRW	AX
	CMPW	AX,BC
	BNZ	$L1_SDATA

	;--------------------------------------------------
	; call main function
	;--------------------------------------------------
	CALL	!_main		; main();
	;--------------------------------------------------
	; call exit function
	;--------------------------------------------------
	CLRW	AX		; exit(0);
_exit:
	BR	$_exit

