/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2011, 2015 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************
* File Name    : r_IICA0.h
* Device(s)    : R5F10267
* Tool-Chain   : CC-RL
* Description  : This file implements device driver for IICA0 slave mode.
* Creation Date: 2015/10/09
************************************************************************/

/***********************************************************************
Global variables and functions
************************************************************************/
extern uint8_t     g_Rx_data[2];        /* received data buffer         */
extern uint16_t    g_Tx_data[2];        /* transmit data buffer         */

void R_IICA0_Init(void);                /* IICA0 buffer initialize      */
uint8_t R_IICA0_Get(uint8_t ptr);       /* get IICA0 received data      */
void R_IICA0_Put(uint8_t ptr,uint16_t data); /* set data to TX buffer   */
uint8_t R_IICA0_Status(void);           /* check IICA0 status           */
